//@flow
import { EditorState } from 'draft-js';
import type { ReduxStoreType } from '../core/types';
import Types from './types';

export const startup = (config :Object, editorState :EditorState, plugins :Array<Object>, store :ReduxStoreType) => ({
  type: Types.CONFIGURE_EDITOR,
  config,
  editorState,
  plugins,
  store
});

export const updateLifeCycle = (lifecycle: string): Object => ({
  type: Types.UPDATE_LIFECYCLE,
  lifecycle
});

export const changeEditorState = (editorState: EditorState, json: Object = {}, activeEntityAtCursor: ?string): Object => ({
  type: Types.EDITOR_CHANGE_STATE,
  json,
  editorState,
  activeEntityAtCursor
});

export const transformState = (json: Object): Object => ({
  type: Types.EDITOR_TRANSFORM_TO_RAW_STATE,
  json
});

export const configureToolbar = (toolbarConfig: Object): Object => ({
  type: Types.CONFIGURE_TOOLBAR,
  toolbarConfig
});

export const linkPromptChangeState = (linkPrompt: Object): Object => ({
  type: Types.LINK_CHANGE_STATE,
  linkPrompt
});

export const configureEditorApi = (subscribers: Object): Object => ({
  type: Types.CONFIGURE_EDITOR_API,
  subscribers
});

export const init = (): Object => ({
  type: Types.MOUNT_EDITOR,
  init: true
});

export const updateWordCount = (wordCount: number): Object => ({
  type: Types.UPDATE_WORD_COUNT,
  wordCount,
});

export const updateCharCount = (charCount: number): Object => ({
  type: Types.UPDATE_CHAR_COUNT,
  charCount
});

export const throwConfigurationError = (message: string): Object => ({
  type: Types.CONFIGURATION_ERROR,
  message
});

export const globalApiConfig = (apiConfig: Object): Object => ({
  type: Types.GLOBAL_API_CONFIG,
  apiConfig
});

export const toggleAlignment = (alignment: string): Object => ({
  type: Types.TOGGLE_ALIGNMENT,
  alignment
});


