// @flow
import React from 'react';
import styles from './button.module.scss';
import autoBind from 'react-autobind';

export const buttonClassNames = styles;
const { menu, simple, ['simple--active']: simpleButtonActiveClassName, ['menu--active']: menuButtonActiveClassName } = buttonClassNames;


export default class Button extends React.Component {

  constructor(){
    super();
    autoBind(this);
  }

  onMouseDown = (e: Object) => {
    e.preventDefault();
    const { toggle, blockType } = this.props;
    toggle(blockType);
  };

  render(){
    const { blockType, active, label, isMenuButton } = this.props;
    const bClassName = isMenuButton ? `${menu} ${menu}--${blockType}` : `${simple} ${simple}--${blockType}`;
    const buttonActiveClassName = isMenuButton ? menuButtonActiveClassName : simpleButtonActiveClassName;
    const className = active ? `${bClassName} ${buttonActiveClassName}` : bClassName;
    return (
      <button className={ className } onMouseDown={ this.onMouseDown }>
        { label }
      </button>
    );
  }
}