// @flow
import { connect } from 'react-redux';
import { Entity, ContentBlock } from 'draft-js';
import { linkPromptChangeState, changeEditorState } from '../../actions/creators';
import Link from './link';

function findLinkEntities(contentBlock: ContentBlock, callback: Function) {
  contentBlock.findEntityRanges(
    (character) => {
      const entityKey = character.getEntity();
      return (
        entityKey !== null &&
        Entity.get(entityKey).getType() === 'LINK'
      );
    },
    callback
  );
}

export default function linkPlugin(): Object {
  return {
    strategy: findLinkEntities,
    component: connect(({ editor: {
        editorState,
        activeEntityAtCursor,
        toolbarConfig: {
          linkCaptions: {
            edit: editCaption,
            unlink: unlinkCaption
          }
        }
    } }) => ({ activeEntityAtCursor, editCaption, unlinkCaption, editorState }), { linkPromptChangeState, changeEditorState })(Link)
  };
}