// @flow
import createLogger from 'redux-logger';
import isDev from 'isdev';
import { getQueryString } from '../utils/queryString';

export const getSettings = (importedBlackList :Array<string>) => {
  const qs :any = getQueryString();
  let blackList = qs && qs.loggingBlacklist ? [...importedBlackList, JSON.parse(qs.loggingBlacklist)] : importedBlackList;
  const settings = {
    enable: qs && qs.logActions || isDev,
    predicate: (getState :Function, { type } :any) => settings.enable && !(blackList.includes(type)),
    collapsed: true,
    duration: true,
    timestamp: true
  };
  return settings;
};

export default function loggerSettingsGenerator(blackList: Array<string>) {
  return createLogger(getSettings(blackList));
}
