import expect from 'expect';
import loggerGenerator, { getSettings } from './logger';

describe('logger settings test', () => {
  let loggerSettings;
  beforeEach(()=>{
    loggerSettings = getSettings(['test', 'test1']);
  });
  it('returns logger function without crashing', () => {
    loggerGenerator(['test']);
  });
  it('logger settings should have enable, predicate and config keys', () => {
    expect(loggerSettings).toIncludeKeys(['enable','predicate','collapsed', 'timestamp', 'duration']);
  });
  it('logger settings should be enabled when logAction is passed in qs', ()=>{
    expect(loggerSettings.enable).toBeTruthy();
  });
  it('predicate should be a function', ()=>{
    expect(loggerSettings.predicate).toBeA(Function);
  });
  it(`predicate should filter "test" and "test1" since they're passed as blacklisted`, ()=>{
    expect(loggerSettings.predicate(()=>{}, { type: 'test' })).toEqual(false)
    expect(loggerSettings.predicate(()=>{}, { type: 'test1' })).toEqual(false)
  });
});