//@flow
import { createStore, compose, applyMiddleware, } from 'redux';
import createSagaMiddleware from 'redux-saga';
import getLogger from './logger';
import rootReducer from './rootReducer';
import sagas from '../sagas';
import type { ReduxStoreType } from './types';

export default function storeGenerator(blackList: Array<string> = []) :ReduxStoreType{
  const sagaMiddleware = createSagaMiddleware();
  const middlewares = [ sagaMiddleware, getLogger(blackList) ];
  const store = createStore(
    rootReducer,
    compose(
      applyMiddleware(
        ...middlewares
      )
    )
  );
  sagaMiddleware.run(sagas);

  return store;
}


