// @flow
import React from 'react';
import ReactDOM from 'react-dom';
import { linkCaptions, buttons } from './config/defaults';
import StewieEditor from './components/editorWrapper';

const defaults = {
  buttons,
  linkCaptions,
};


function getDomNode({ selector, el, }): HTMLElement | null{
  const node = el || document.querySelector(selector);
  if (!(node instanceof HTMLElement)) {
    /*  eslint-disable no-console*/
    console.warn(`Stewie should be mounted to a DOM node`, {
      node, el, selector,
    });
    return null;
  }
  return node;
}

function StewieEditorFactory(factoryConfig :Object = {}){
  const node = getDomNode(factoryConfig);
  if (node) {
    ReactDOM.render(<StewieEditor { ...factoryConfig.config }/>, node);
  }
}

export {
  StewieEditor,
  StewieEditorFactory,
  defaults,
};