// @flow
/*eslint-disable no-constant-condition */

import isEqual from 'lodash/fp/equals';
import { take, put, } from 'redux-saga/effects';
import Types from '../actions/types';
import { transformState, updateWordCount, updateCharCount } from '../actions/creators';
import { convertToRaw } from 'draft-js';
import { getWordCount, getCharCount } from '../services/counter';

export function * watchEditorChange(): Generator<*, void, void> {
  while (true){
    let action: any = yield take(Types.EDITOR_CHANGE_STATE);
    const { editorState, json } = action;
    const newJsonState = convertToRaw(editorState.getCurrentContent());
    if (!isEqual(json, newJsonState)) {
      yield put(transformState(newJsonState));
      yield put(updateWordCount(getWordCount(editorState)));
      yield put(updateCharCount(getCharCount(editorState)));
    }
  }
}