
import { watchEditorChange } from './editorSaga';
import Types from '../actions/types';
import testSaga from 'redux-saga-test-plan';
import { EditorState, CompositeDecorator, convertFromRaw } from 'draft-js';
import storeGenerator from '../core/storeGenerator';
import mockedJSONState from '../__mocks__/editorState.json';

describe('(sagas/editorSaga_test.js) - test editor sagas', ()=>{
  let saga;
  beforeEach(()=>{
    saga = testSaga(watchEditorChange);
  });
  it('watchEditorChange saga flow is correct without config', ()=>{
    const mockedEditorState = EditorState.createWithContent(
      convertFromRaw(mockedJSONState),
      new CompositeDecorator([])
    );
    saga.next().take(Types.EDITOR_CHANGE_STATE);
    saga.next({
      editorState: mockedEditorState,
      json: {}
    }).put({
      type: Types.EDITOR_TRANSFORM_TO_RAW_STATE,
      json: mockedJSONState
    });

    saga.next().put({
      type: Types.UPDATE_WORD_COUNT,
      wordCount: 16
    });

    saga.next().put({
      type: Types.UPDATE_CHAR_COUNT,
      charCount: 68
    });
  });
});