// @flow
import { fork, take } from 'redux-saga/effects';
import { watchStartup } from './startupSaga';
import { watchEditorChange } from './editorSaga';
import { watchToolbarConfig } from './toolbarSaga';
import Types from '../actions/types';
import apiSaga from './apiSaga';

export default function * rootSaga(): Generator<*, void, Object> {
  yield fork(watchStartup);
  yield fork(watchEditorChange);
  yield fork(watchToolbarConfig);
  const action: any = yield take(Types.CONFIGURE_EDITOR);
  yield fork(apiSaga, action.store);
}
