import expect from 'expect';
import { getWordCount, getCharCount } from './counter';
import { EditorState, convertFromRaw } from 'draft-js';
import mockedJSONState from '../__mocks__/editorState.json';

describe('(services/counter_test.js) - counter test', ()=>{
  let editorState;
  beforeEach(()=>{
    editorState = EditorState.createWithContent(
      convertFromRaw(mockedJSONState)
    );
  });
  it('should return correct wordCount', ()=>{
    expect(getWordCount(editorState)).toBe(16);
  });
  it('should return correct charCount', ()=>{
    expect(getCharCount(editorState)).toBe(68);
  });
});