// @flow
import windowRoot from 'window-or-global';


function dashDelimitedToCamelCase(string :string) :string{
  return string.replace(
    /-([a-z])/g,
    (lettersAfterDash) => lettersAfterDash[0].toUpperCase()
  );
}

function decode(string :string) :string{
  return decodeURIComponent(string.replace(/\+/g, ' '));
}

function deserializeQueryString(inputQuery :string, queryStringObj :Object = {}) :Object{
  const search = /([^&=]+)=?([^&]*)/g;
  const query = inputQuery.substring(1);
  let matches = search.exec(query);
  while (matches) {
    const [fullKey, onlyKey, rawValue, ] = matches;
    const isOnlyKey = fullKey === onlyKey;
    const value = isOnlyKey ? true : decode(rawValue);
    const key = dashDelimitedToCamelCase(onlyKey);
    queryStringObj[key] = value;
    matches = search.exec(query);
  }
  return queryStringObj;
}


export const getQueryString = () :Object | boolean => {
  return windowRoot.location ? deserializeQueryString(windowRoot.location.search, deserializeQueryString(windowRoot.location.hash)) : false;
};

